<template>
  <div>
    <v-row v-if="formState.ready" dense>
      <v-col>
        <v-form ref="form">
          <v-row dense>
            <gz-error :error-box-message="formState.errorBoxMessage"></gz-error>
            <v-col cols="12" sm="6" lg="4" xl="3">
              <v-select
                ref="eventType"
                v-model="obj.eventType"
                dense
                :items="selectLists.eventTypes"
                item-text="name"
                item-value="id"
                :readonly="formState.readOnly"
                :label="$sock.t('NotifyEventType')"
                data-cy="eventType"
                :rules="[form().integerValid(this, 'eventType')]"
                :error-messages="form().serverErrors(this, 'eventType')"
                @input="fieldValueChanged('eventType')"
              ></v-select>
            </v-col>
            <v-col v-if="showServerStatus" cols="12" sm="6" lg="4" xl="3">
              <v-select
                ref="idValue"
                v-model="obj.idValue"
                dense
                :items="selectLists.serverStates"
                item-text="name"
                item-value="id"
                :readonly="formState.readOnly"
                :label="$sock.t('ServerState')"
                data-cy="idValue"
                :rules="[form().integerValid(this, 'idValue')]"
                :error-messages="form().serverErrors(this, 'idValue')"
                @input="fieldValueChanged('idValue')"
              ></v-select>
            </v-col>

            <v-col v-if="showDecValue" cols="12" sm="6" lg="4" xl="3">
              <gz-decimal
                ref="decValue"
                v-model="obj.decValue"
                :readonly="formState.readOnly"
                :label="$sock.t('Total')"
                data-cy="decValue"
                :rules="[
                  form().decimalValid(this, 'decValue'),
                  form().required(this, 'decValue')
                ]"
                :error-messages="form().serverErrors(this, 'decValue')"
                @input="fieldValueChanged('decValue')"
              ></gz-decimal>
            </v-col>

            <v-col v-if="showIntegerDecValue" cols="12" sm="6" lg="4" xl="3">
              <v-text-field
                ref="decValue"
                v-model="obj.decValue"
                dense
                :readonly="formState.readOnly"
                :clearable="!formState.readOnly"
                :label="$sock.t('UiFieldDataTypesInteger')"
                data-cy="decValue"
                :rules="[form().integerValid(this, 'decValue')]"
                :error-messages="form().serverErrors(this, 'decValue')"
                type="number"
                @click:clear="fieldValueChanged('decValue')"
                @input="fieldValueChanged('decValue')"
              ></v-text-field>
            </v-col>

            <v-col v-if="showAgeValue" cols="12" sm="6" lg="4" xl="3">
              <gz-duration-picker
                ref="ageValue"
                v-model="obj.ageValue"
                :readonly="formState.readOnly"
                :label="$sock.t('Duration')"
                :show-seconds="false"
                data-cy="ageValue"
                :error-messages="form().serverErrors(this, 'ageValue')"
                @input="fieldValueChanged('ageValue')"
              ></gz-duration-picker>
            </v-col>

            <v-col v-if="showSockType" cols="12" sm="6" lg="4" xl="3">
              <v-select
                ref="sockType"
                v-model="obj.sockType"
                dense
                :items="selectLists.coreSockTypes"
                item-text="name"
                item-value="id"
                :readonly="formState.readOnly"
                :label="$sock.t('SockType')"
                data-cy="sockType"
                :rules="[
                  form().required(this, 'sockType'),
                  form().integerValid(this, 'sockType')
                ]"
                :error-messages="form().serverErrors(this, 'sockType')"
                @input="fieldValueChanged('sockType')"
              ></v-select>
            </v-col>
            <!-- :menu-props="{ contentClass: 'cySockType' }" -->
            <v-col v-if="showAdvanceNotice" cols="12" sm="6" lg="4" xl="3">
              <gz-duration-picker
                ref="advanceNotice"
                v-model="obj.advanceNotice"
                :readonly="formState.readOnly"
                :label="$sock.t('NotifySubscriptionPendingSpan')"
                :show-seconds="false"
                data-cy="advanceNotice"
                :error-messages="form().serverErrors(this, 'advanceNotice')"
                @input="fieldValueChanged('advanceNotice')"
              ></gz-duration-picker>
            </v-col>

            <v-col v-if="showDeliveryMethod" cols="12" sm="6" lg="4" xl="3">
              <v-select
                ref="deliveryMethod"
                v-model="obj.deliveryMethod"
                dense
                :items="selectLists.deliveryMethods"
                item-text="name"
                item-value="id"
                :readonly="formState.readOnly"
                :label="$sock.t('NotifyDeliveryMethod')"
                data-cy="deliveryMethod"
                :rules="[form().integerValid(this, 'deliveryMethod')]"
                :error-messages="form().serverErrors(this, 'deliveryMethod')"
                @input="fieldValueChanged('deliveryMethod')"
              ></v-select>
            </v-col>

            <v-col v-if="showDeliveryAddress" cols="12" sm="6" lg="4" xl="3">
              <v-text-field
                ref="deliveryAddress"
                v-model="obj.deliveryAddress"
                dense
                :readonly="formState.readOnly"
                :clearable="!formState.readOnly"
                :label="$sock.t('NotifyDeliveryAddress')"
                :rules="[form().required(this, 'deliveryAddress')]"
                :error-messages="form().serverErrors(this, 'deliveryAddress')"
                data-cy="deliveryAddress"
                @click:clear="fieldValueChanged('deliveryAddress')"
                @input="fieldValueChanged('deliveryAddress')"
              ></v-text-field>
            </v-col>

            <v-col v-if="showLinkReportId" cols="12" sm="6" lg="4" xl="3">
              ATTACH REPORT stub: dynamic list of reports for type
            </v-col>

            <v-col v-if="showTags" cols="12">
              <gz-tag-picker
                ref="tags"
                v-model="obj.tags"
                :label="$sock.t('TaggedWith')"
                :readonly="formState.readOnly"
                data-cy="tags"
                :error-messages="form().serverErrors(this, 'tags')"
                @input="fieldValueChanged('tags')"
              ></gz-tag-picker>
            </v-col>
          </v-row>
        </v-form>
      </v-col>
    </v-row>
    <v-overlay :value="!formState.ready || formState.loading">
      <v-progress-circular indeterminate :size="64" />
    </v-overlay>
  </div>
</template>
<script>
const FORM_KEY = "notify-subscription";
const API_BASE_URL = "notify-subscription/";
export default {
  data() {
    return {
      selectLists: {
        serverStates: [],
        eventTypes: [],
        deliveryMethods: [],
        coreSockTypes: []
      },
      obj: {
        id: 0,
        concurrency: 0,
        userId: this.$store.state.userId,
        sockType: 10, //<--this is deliberate to force a valid type to be selected so that user *must* have a selection if typed, save will reset to zero if not used
        eventType: 0,
        advanceNotice: "00:00:00",
        idValue: 0,
        decValue: 0,
        deliveryMethod: 1,
        deliveryAddress: null,
        linkReportId: 0,
        tags: []
      },
      formState: {
        ready: false,
        dirty: false,
        valid: true,
        readOnly: false,
        loading: true,
        errorBoxMessage: null,
        appError: null,
        serverError: {}
      },
      rights: window.$gz.role.defaultRightsObject(),
      sockType: window.$gz.type.NotifySubscription
    };
  },
  computed: {
    showDeliveryAddress() {
      return this.obj.deliveryMethod == 2;
    },
    showDeliveryMethod() {
      return this.obj.eventType != 27;
    },
    showServerStatus() {
      switch (this.obj.eventType) {
        case 36:
        case 37:
          return true;
        default:
          return false;
      }
    },

    showDecValue() {
      //WorkorderTotalExceedsThreshold = 23 The "Andy"
      return this.obj.eventType == 23; // || this.obj.eventType == 11; //service bank threshold
    },
    showIntegerDecValue() {
      //UnitMeterReadingMultipleExceeded=26,
      return this.obj.eventType == 26;
    },
    showSockType() {
      switch (this.obj.eventType) {
        case 1:
        case 2:
        case 3:
        case 10:
          return true;
        default:
          return false;
      }
    },
    showAdvanceNotice() {
      switch (this.obj.eventType) {
        case 5:
        case 11:
        case 12:
        case 14:
        case 16:
        case 21:
        case 22:
        case 25:
        case 34:
        case 38:
          return true;
        default:
          return false;
      }
    },
    showAgeValue() {
      switch (this.obj.eventType) {
        case 24:
        case 29:
        case 10:
        case 37:
        case 39:
          return true;
        default:
          return false;
      }
    },
    showLinkReportId() {
      //New NOTE NOTE: This is probably not required at the mo as customers are expected to login and view the reports as configured in global settings,
      //so, if post release nothing relies on this it might be removed
      //
      //NOTE: Currently projected: Only Quotes and Workorders are involved in sending as attached reports
      //And only to customers and only single items, not lists so it's doable to indicate a report id
      //and send a link from notification to open the report
      switch (this.obj.eventType) {
        case 999: //to be filled in later
          return true;
        default:
          return false;
      }
    },
    showTags() {
      if (!window.$gz.store.getters.isCustomerUser) {
        //customers NEVER see tags anywhere, that's private information and they do not use or require it
        switch (this.obj.eventType) {
          case 27: //General notification
          case 20: //backup status
          case 28: //server ops problem
          case 31: //workordercreatedforcustomer customer notification, no tags
          case 32: //pm generation failure, like ops notice sb on any item
            return false;
          default:
            return true;
        }
      } else {
        return false;
      }
    }
  },
  watch: {
    formState: {
      handler: function(val) {
        if (this.formState.loading) {
          return;
        }
        if (val.dirty && val.valid && !val.readOnly) {
          window.$gz.eventBus.$emit("menu-enable-item", FORM_KEY + ":save");
        } else {
          window.$gz.eventBus.$emit("menu-disable-item", FORM_KEY + ":save");
        }
        if (!val.dirty && val.valid && !val.readOnly) {
          window.$gz.eventBus.$emit(
            "menu-enable-item",
            FORM_KEY + ":duplicate"
          );
          window.$gz.eventBus.$emit("menu-enable-item", FORM_KEY + ":new");
        } else {
          window.$gz.eventBus.$emit(
            "menu-disable-item",
            FORM_KEY + ":duplicate"
          );
          window.$gz.eventBus.$emit("menu-disable-item", FORM_KEY + ":new");
        }
      },
      deep: true
    }
  },
  async created() {
    const vm = this;
    try {
      await initForm(vm);
      vm.rights = window.$gz.role.getRights(window.$gz.type.NotifySubscription);
      vm.formState.readOnly = !vm.rights.change;
      window.$gz.eventBus.$on("menu-click", clickHandler);
      let setDirty = false;
      //id 0 means create or duplicate to new
      if (vm.$route.params.recordid != 0) {
        //is there already an obj from a prior operation?
        if (this.$route.params.obj) {
          //yes, no need to fetch it
          this.obj = this.$route.params.obj;
        } else {
          await vm.getDataFromApi(vm.$route.params.recordid);
        }
      } else {
        //Might be a duplicate and contain another record
        if (this.$route.params.obj) {
          this.obj = this.$route.params.obj;
          this.obj.concurrency = undefined;
          this.obj.id = 0;
          setDirty = true;
        } else {
          //default to their configured email address on new record
          this.obj.deliveryAddress = this.$store.state.userOptions.emailAddress;
        }
      }
      window.$gz.form.setFormState({
        vm: vm,
        loading: false,
        dirty: setDirty,
        valid: true
      });
      generateMenu(vm);
    } catch (error) {
      window.$gz.errorHandler.handleFormError(error, vm);
    } finally {
      vm.formState.ready = true;
    }
  },
  async beforeRouteLeave(to, from, next) {
    if (!this.formState.dirty || JUST_DELETED) {
      next();
      return;
    }
    if ((await window.$gz.dialog.confirmLeaveUnsaved()) === true) {
      next();
    } else {
      next(false);
    }
  },
  beforeDestroy() {
    window.$gz.eventBus.$off("menu-click", clickHandler);
  },
  methods: {
    canSave: function() {
      return this.formState.valid && this.formState.dirty;
    },
    canDuplicate: function() {
      return this.formState.valid && !this.formState.dirty;
    },
    sockTypes: function() {
      return window.$gz.type;
    },
    form() {
      return window.$gz.form;
    },
    fieldValueChanged(ref) {
      if (
        this.formState.ready &&
        !this.formState.loading &&
        !this.formState.readOnly
      ) {
        //if it's a general notification make sure delivery is set to email
        if (ref == "eventType" && this.obj.eventType == 27) {
          this.obj.deliveryMethod = 2;
        }
        window.$gz.form.fieldValueChanged(this, ref);
      }
    },
    async getDataFromApi(recordId) {
      const vm = this;
      vm.formState.loading = true;
      if (!recordId) {
        throw new Error(FORM_KEY + "::getDataFromApi -> Missing recordID!");
      }
      try {
        window.$gz.form.deleteAllErrorBoxErrors(vm);
        const res = await window.$gz.api.get(API_BASE_URL + recordId);
        if (res.error) {
          if (res.error.code == "2010") {
            window.$gz.form.handleObjectNotFound(vm);
          }
          vm.formState.serverError = res.error;
          window.$gz.form.setErrorBoxErrors(vm);
          vm.formState.loading = false;
        } else {
          vm.obj = res.data;
          generateMenu(vm);
          window.$gz.form.setFormState({
            vm: vm,
            dirty: false,
            valid: true,
            loading: false,
            readOnly: res.data.eventType == 27 && res.data.deliveryMethod == 1 //default in-app notification is read only
          });
        }
      } catch (error) {
        window.$gz.errorHandler.handleFormError(error, vm);
        vm.formState.loading = false;
      }
    },
    async submit() {
      const vm = this;
      if (vm.canSave == false) {
        return;
      }

      try {
        vm.formState.loading = true;
        window.$gz.form.deleteAllErrorBoxErrors(vm);

        //don't include invalid settings (could be set by duplicate option)
        if (!this.showAgeValue) {
          this.obj.ageValue = "00:00:00";
        }
        if (!this.showAdvanceNotice) {
          this.obj.advanceNotice = "00:00:00";
        }
        if (!this.showDecValue && !this.showIntegerDecValue) {
          this.obj.decValue = 0;
        }

        if (!this.showQuoteStatus && !this.showServerStatus) {
          this.obj.idValue = 0;
        }

        if (!this.showSockType) {
          this.obj.sockType = 0;
        }

        //don't send the deliveryaddress if it's an in-app notification
        if (vm.obj.deliveryMethod == 1) {
          vm.obj.deliveryAddress = null;
        }
        const res = await window.$gz.api.upsert(API_BASE_URL, vm.obj);
        if (res.error) {
          vm.formState.serverError = res.error;
          window.$gz.form.setErrorBoxErrors(vm);
        } else {
          if (res.data.id) {
            //POST
            vm.obj = res.data;
            this.$router.replace({
              name: "home-notify-subscription",
              params: {
                recordid: res.data.id,
                obj: res.data
              }
            });
          } else {
            //PUT
            vm.obj.concurrency = res.data.concurrency;
          }
          window.$gz.form.setFormState({
            vm: vm,
            dirty: false,
            valid: true
          });
        }
      } catch (ex) {
        window.$gz.errorHandler.handleFormError(ex, vm);
      } finally {
        vm.formState.loading = false;
      }
    },
    async remove() {
      try {
        const dialogResult = await window.$gz.dialog.confirmDelete();
        if (dialogResult != true) {
          return;
        }
        this.formState.loading = true;
        if (this.$route.params.recordid == 0) {
          JUST_DELETED = true;
          this.$router.go(-1);
        } else {
          window.$gz.form.deleteAllErrorBoxErrors(this);
          const res = await window.$gz.api.remove(
            API_BASE_URL + this.$route.params.recordid
          );
          if (res.error) {
            this.formState.serverError = res.error;
            window.$gz.form.setErrorBoxErrors(this);
          } else {
            JUST_DELETED = true;
            this.$router.go(-1);
          }
        }
      } catch (ex) {
        window.$gz.errorHandler.handleFormError(ex, this);
      } finally {
        this.formState.loading = false;
      }
    },
    duplicate() {
      this.$router.push({
        name: "home-notify-subscription",
        params: {
          recordid: 0,
          obj: this.obj
        }
      });
    }
  }
};

/////////////////////////////
//
//
async function clickHandler(menuItem) {
  if (!menuItem) {
    return;
  }
  const m = window.$gz.menu.parseMenuItem(menuItem);
  if (m.owner == FORM_KEY && !m.disabled) {
    switch (m.key) {
      case "save":
        m.vm.submit();
        break;
      case "delete":
        m.vm.remove();
        break;
      case "new":
        m.vm.$router.push({
          name: "home-notify-subscription",
          params: { recordid: 0 }
        });
        break;
      case "duplicate":
        m.vm.duplicate();
        break;
      default:
        window.$gz.eventBus.$emit(
          "notify-warning",
          FORM_KEY + "::context click: [" + m.key + "]"
        );
    }
  }
}

//////////////////////
//
//
function generateMenu(vm) {
  const menuOptions = {
    isMain: false,
    readOnly: vm.formState.readOnly,
    icon: "$sockiBullhorn",
    title: "NotifySubscription",
    helpUrl: "home-notify-subscriptions",
    formData: {
      sockType: window.$gz.type.NotifySubscription,
      recordId: vm.$route.params.recordid
    },
    menuItems: []
  };

  if (vm.rights.change) {
    menuOptions.menuItems.push({
      title: "Save",
      icon: "$sockiSave",
      surface: true,
      key: FORM_KEY + ":save",
      vm: vm
    });
  }

  if (vm.rights.change) {
    menuOptions.menuItems.push({
      title: "New",
      icon: "$sockiPlus",
      key: FORM_KEY + ":new",
      vm: vm
    });
  }

  if (vm.rights.change && vm.$route.params.recordid != 0) {
    menuOptions.menuItems.push({
      title: "Duplicate",
      icon: "$sockiClone",
      key: FORM_KEY + ":duplicate",
      vm: vm
    });
  }

  if (vm.rights.delete && vm.$route.params.recordid != 0) {
    menuOptions.menuItems.push({
      title: "Delete",
      icon: "$sockiTrashAlt",
      surface: false,
      key: FORM_KEY + ":delete",
      vm: vm
    });
  }
  menuOptions.menuItems.push({ divider: true, inset: false });
  window.$gz.eventBus.$emit("menu-change", menuOptions);
}

let JUST_DELETED = false;

/////////////////////////////////
//
//
async function initForm(vm) {
  await fetchTranslatedText();
  await populateSelectionLists(vm);
}

//////////////////////////////////////////////////////////
//
// Ensures UI translated text is available
//
async function fetchTranslatedText() {
  await window.$gz.translation.cacheTranslations([
    "NotifySubscriptionPendingSpan",
    "NotifySubscription",
    "NotifyDeliveryMethod",
    "NotifyEventType",
    "NotifyDeliveryAddress",
    "Tags",
    "Duration",
    "TaggedWith",
    "Total",
    "UiFieldDataTypesInteger",
    "ServerState"
  ]);
}

//////////////////////
//
//
async function populateSelectionLists(vm) {
  //ensure the pick lists required are pre-fetched
  await window.$gz.enums.fetchEnumList("NotifyEventType");
  const tempEventTypes = window.$gz.enums.getSelectionList("NotifyEventType");
  if (window.$gz.store.getters.isCustomerUser) {
    vm.selectLists.eventTypes = tempEventTypes.filter(z => {
      //return true if it's a type allowed by customer *and* they have customerRights to it
      switch (z.id) {
        case 6:
          return window.$gz.store.state.customerRights.notifyCSRAccepted;
        case 7:
          return window.$gz.store.state.customerRights.notifyCSRRejected;
        case 21:
          return window.$gz.store.state.customerRights.notifyServiceImminent;
        case 30: //cust or inside user both
          return window.$gz.store.state.customerRights.notifyWOCompleted;
        case 31:
          return window.$gz.store.state.customerRights.notifyWOCreated;
        default:
          return false;
      }
    });
  } else {
    vm.selectLists.eventTypes = tempEventTypes.filter(
      z => z.id != 6 && z.id != 7 && z.id != 21 && z.id != 31
    );
  }
  await window.$gz.enums.fetchEnumList("NotifyDeliveryMethod");
  vm.selectLists.deliveryMethods = window.$gz.enums.getSelectionList(
    "NotifyDeliveryMethod"
  );
  await window.$gz.enums.fetchEnumList("coreview");
  vm.selectLists.coreSockTypes = window.$gz.enums.getSelectionList("coreview");

  await window.$gz.enums.fetchEnumList("ServerState");
  vm.selectLists.serverStates = window.$gz.enums.getSelectionList(
    "ServerState"
  );
}
/*
ServerStateStatusChange = 36,
ServerStateStatusAge=37,
SubscriptionServerExpiring = 38,
SubscriptionServerLastUpdateAge = 39,
SubscriptionServerRequestReceived = 40,
LicenseTrialRequestReceived = 41,
PurchaseNotificationReceived = 42
*/
</script>
